=== debian/changelog ===
libtk-img (1:2.1.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 09 Aug 2025 22:14:46 +0300

libtk-img (1:2.0.1+dfsg1-2) unstable; urgency=medium

  * Build two sets of libraries, one for Tcl/Tk 8.6, the other for Tcl/Tk 9.0.
  * Bump standards version to 4.7.2.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 21 Mar 2025 00:24:03 +0300
